<?php
/* ---------- Configure here ----------------------------- */
  // path to image magicks convert
  $config['convert']    = '/usr/bin/X11/convert';
  // temp directory
  $config['tempdir']    = '/tmp';
  // maximum image dimension in detail view
  $config['max']        = 600;

  //select which exif tags you like to see (left value) and how they
  //should be named (right value) add or remove any tag you like
  $EXIF['FileName']     = 'file name';
  $EXIF['FileSize']     = 'file size';
  $EXIF['FileDateTime'] = 'file date';
  $EXIF['DateTime']     = 'photo date';
  $EXIF['Width']        = 'width';
  $EXIF['Height']       = 'height';
  $EXIF['make']         = 'manufacturer';
  $EXIF['model']        = 'camera model';
  $EXIF['exposureTime'] = 'exposure time';
  $EXIF['fnumber']      = 'focal length';
  $EXIF['flashUsed']    = 'flash used?';
/* ---------- No need for changes below ------------------ */

  require ("exifWriter.inc");

  if (get_magic_quotes_gpc()) {
    if (!empty($_GET))    remove_magic_quotes($_GET);
    if (!empty($_POST))   remove_magic_quotes($_POST);
    if (!empty($_COOKIE)) remove_magic_quotes($_COOKIE);
    if (!empty($_REQUEST)) remove_magic_quotes($_REQUEST);
    ini_set('magic_quotes_gpc', 0);
  }
  set_magic_quotes_runtime(0);

  if(!empty($_REQUEST[thumb])){
    mkThumb($_REQUEST[thumb]);
  }
?>

<html>
<head>
  <title>My Pictures</title>
  
  <style type="text/css">
  <!--
    body,p,div,td {font-family:Lucida,Helvetica,Verdana,Arial,Sans-Serif;
                   font-size: 12px;}
    a:link { text-decoration:none; color:#0033CC }
    a:visited { text-decoration:none; color:#0033CC }
    a:active { text-decoration:none; color:#0033CC }
    a:hover { text-decoration:underline; color:#FF6600 }
    a.folderlink { font-weight:bold; }
    a.imagelink { font-weight:bold; }
    a.edit {font-size:9px; color:#cccccc}
    .comment{
        font-family: Lucida,Helvetica,Verdana,Arial,Sans-Serif;
        font-size: 10px; }
    .com{
        font-family: Lucida,Helvetica,Verdana,Arial,Sans-Serif;
        font-size: 10px;
        background-color: #FFFFFF;
        border-color: #000000;
        border-style: solid;
        border-width: 1px;
        padding-left: 2px;
    }
    .combutton{
        font-family: Lucida,Helvetica,Verdana,Arial,Sans-Serif;
        font-size: 10px;
        border-color: #000000;
        border-style: solid;
        border-width: 1px;
        padding: 0px;
    }
  //-->
  </style>
</head>
<body>
<a name="top"></a>

<?php
  $path   = $_REQUEST[path];
  $img    = $_REQUEST[img];
  $search = $_REQUEST[search];
  
  if(empty($path)&&!empty($img)){$path = dirname($img);}
  if(empty($path)){$path = '.';}

  if(!empty($search)){
    print '<h1>';
    showLinkPath($path);
    print '<a href="?search='.urlencode($search).'&path='.urlencode($path).'">Search...</a>';
    print '</h1>';
    searchImages($path,$search);
  }elseif(!empty($_REQUEST[dirinfo])){
    if(isset($_REQUEST[com])){
      saveDirComment($_REQUEST[dirinfo],$_REQUEST[com]);
    }
    showDirinfo($_REQUEST[dirinfo]);
  }elseif(empty($img)){
    showList($path);
  }else{
    if(isset($_REQUEST[com])){
      saveComment($img,$_REQUEST[com]);
    }
    if(isset($_REQUEST[rotate])){
      rotate($img,$_REQUEST[rotate]);
    }
    showImage($img);
  }
?>

<hr size="1" noshade="noshade">
<table width="100%">
  <tr>
    <td valign="top" align="left">
      <form method="GET">
        <img src=".img/search.png" align="middle" width="25" height="25">
        <input type="text" name="search" class="com" size="40" value="<?php echo htmlspecialchars($search); ?>">
        <input type="hidden" name="path" value="<?php echo htmlspecialchars($path); ?>">
        <input type="submit" value="Search" class="combutton">
      </form>
    </td>
    <td valign="top" align="right">
      <?php button('#top','top.png','back to top','left'); ?>
    </td>
  <tr>
</table>
</body>
</html>


<?php

function showList($path='.'){
  $dirs = readDirectories($path);
  $imgs = readImages($path);
  
  print '<h1>';
  showLinkPath($path);
  print '</h1>';
  
  $count = 0;
  
  print '<table width="100%">';
  print '<tr>';
  foreach($dirs as $dir){
    print '<td><table>';
    print '<tr>';
    print '<td align="center" valign="top" width="122">';
    print '<a href="?path='.urlencode($path.'/'.$dir).'" name="'.$dir.'">';
    print '<img src=".img/folder.png" border="0">';
    print '</a>';
    print '</td>';
    print '<td valign="top">';
    print '<a href="?path='.urlencode($path.'/'.$dir).'" class="folderlink">';
    print $dir;
    print '</a>';
    print '<br />';
    print '<span class="comment">';
    print nl2br(htmlspecialchars(getDirComment($path.'/'.$dir)));
    print '</span>';
    print ' <a href="?dirinfo='.urlencode($path.'/'.$dir).'" class="edit">[edit]</a>';
    print '</td>';
    print '</tr>';
    print '</table></td>';
    $count++;
    if(($count % 3)==0) print '</tr><tr>';
  }
  foreach($imgs as $img){
    print '<td>';
    showThumb($path,$img);
    print '</td>';
    $count++;
    if(($count % 3)==0) print '</tr><tr>';
  }
  print '</tr>';
  print '</table>';
}

function showThumb($path,$img){
  print '<table width="100%">';
  print '<tr>';
  print '<td align="center" valign="top" width="122">';
  print '<a href="?img='.urlencode($path.'/'.$img).'#img" name="'.$img.'">';
  print '<img src="'.getThumbnail($path,$img).'" border="0" />';
  print '</a>';
  print '</td>';
  print '<td valign="top">';
  print '<a href="?img='.urlencode($path.'/'.$img).'#img" class="imagelink">';
  print $img;
  print '</a>';
  print '<br />';
  print '<span class="comment">'.nl2br(htmlspecialchars(getImgComment($path.'/'.$img))).'</span>';
  print '</td>';
  print '</tr>';
  print '</table>';
}

function showImage($img){
  global $config;
  $MAX    = $config['max'];
  $size   = getimagesize(fullpath($img));
  $width  = $size[0];
  $height = $size[1];
  if ($width <= $height){
    $ratio = $MAX/$height;
  }else{
    $ratio = $MAX/$width;
  }
  $w = $ratio*$width;
  $h = $ratio*$height;

?>  
  <h1><?php showLinkPath(dirname($img),basename($img)); ?></h1>
  <table width="100%">
    <tr>
      <td align="center" valign="top" height="<?php echo $MAX; ?>">
        <a href="<?php echo $img; ?>?<?php echo time(); ?>" name="img"><img src="<?php echo $img; ?>?<?php echo time(); ?>" width="<?php echo $w; ?>" height="<?php echo $h; ?>" border="0" /></a>
      </td>
      <td valign="top" rowspan="2">
        <?php showExif($img); ?><br>

        <table width="100%">
          <tr>
            <td align="left" width="33%">
              <?php button('?img='.$img.'&rotate=left','rotleft.png','Rotate&nbsp;left'); ?>
            </td>
            <td></td>
            <td align="right" width="33%">
              <?php button('?img='.$img.'&rotate=right','rotright.png','Rotate&nbsp;right','left'); ?>
            </td>
          </tr>
          <tr>
            <td align="left" width="33%">
              <?php button(getLink($img,false),'left.png','previous'); ?>
            </td>
            <td align="center" width="33%">
              <?php button('?path='.dirname($img).'#'.basename($img),'up.png','back'); ?>
            </td>
            <td align="right" width="33%">
              <?php button(getLink($img,true),'right.png','next','left'); ?>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
<?php 
}

function showDirinfo($path){
  print '<h1>';
  showLinkPath($path);
  print '<a href="?dirinfo='.urlencode($path.'/'.$dir).'">Comment</a>';
  print '</h1>';

  $com = getDirComment($path);

  ?>
  <form method="post">
  <input type="hidden" name="dirinfo" value="<?php echo $path; ?>" />
  <table>
    <tr>
      <td>
        <img src=".img/folder.png" border="0">
      </td>
      <td>
        Folder Comment:<br />
        &nbsp;&nbsp;&nbsp;&nbsp;<textarea class="com" name="com" rows="7" cols="40"><?php echo htmlspecialchars($com); ?></textarea><br />
        &nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="save" class="combutton" />
      </td>
    </tr>
  </table>
  <?php 
}

function saveDirComment($path,$com){
  $fp = fopen(fullpath($path).'/.dirinfo.txt','w');
  fwrite($fp, htmlentities($com));
  fclose($fp);
}

function button($link,$icon,$text,$talign='right'){
  if(empty($link)) return;
    
  print '<a href="'.$link.'" title="'.$text.'">';
  if ($talign == 'right'){
    print '<img src=".img/'.$icon.'" border="0" width="25" height="25" align="middle">';
    print '&nbsp;';
  }
  print $text;
  if ($talign == 'left'){
    print '&nbsp;';
    print '<img src=".img/'.$icon.'" border="0" width="25" height="25" align="middle">';
  }
}

function showExif($img){
  global $EXIF;
  $er = new phpExifReader(fullpath($img));
  if(!$er){
    return '';
  }
  $er->processFile();
  $exif = $er->getImageInfo();

  print '<table>';
  foreach(array_keys($EXIF) as $key){
    if (empty($exif[$key])) continue;
    print '<tr>';
    print '<td valign="top" nowrap="nowrap">'.$EXIF[$key].'</td>';
    print '<td valign="top">:</td>';
    print '<td valign="top">'.$exif[$key].'</td>';
    print '</tr>';
  }

  if(is_array($exif['imageComment'])){
    $val = nohtmlentities(join("\n",$exif['imageComment']));
  }else{
    $val = nohtmlentities($exif['imageComment']);
  }
  print '<tr>';
  print '<td valign="top">Comments</td>';
  print '<td valign="top">:</td>';
  print '<td valign="top">';
  print '<form method="post">';
  print '<input type="hidden" name="img" value="'.$img.'" />';
  print '<textarea rows="7" cols="30" wrap="virtual" name="com" class="com">';
  print htmlspecialchars($val);
  print '</textarea><br />';
  print '<input type="submit" class="combutton" value="save">';
  print '</form>';
  print '</td>';
  print '</tr>';

  print '</table>';
}

function getLink($img,$next){
  $me   = basename($img);
  $path = dirname($img);
  $fullpath = fullpath($path);
  $files=array();
  $dh = opendir($fullpath);
  while (($file = readdir($dh)) !== false) {
    if (is_dir("$fullpath/$file")) continue;
    if (preg_match('/\.(jpe?g|gif|png)$/i',$file)){
      $files[]=$file;
    }
  }
  closedir($dh);
  sort($files,SORT_STRING);
  
  $pos = array_search($me,$files);
  if(is_null($pos)){
    return '';
  }
  if($pos === false){
    return '';
  }
  
  if($next){
    $pos++;
  }else{
    $pos--;
  }
  
  if(empty($files[$pos])){
    return '';
  }
  
  return '?img='.urlencode($path.'/'.$files[$pos]).'#img';
}

function showLinkPath($path,$img=''){
  $parts = split('/',$path);
  for($i=0; $i < count($parts); $i++){
    $links = array_slice($parts,0,$i+1);
    $link = join('/',$links);
    $name = $parts[$i];
    if ($name == '.') $name = 'My Pictures';
    #calculate jumpname
    $jump='';
    if($i == count($parts)-1){
      if(!empty($img)){
        $jump='#'.urlencode($img);
      }
    }else{
      $jump='#'.urlencode($parts[$i+1]);
    }
    print '<a href="?path='.urlencode($link).$jump.'">'.$name.'</a>';
    print '/';
  }
}

function saveComment($img,$com){
  $er = new phpExifWriter($img);
  $er->addComment(htmlentities($com));
  $er->writeImage($img);
}

function rotate($img,$direction){
  global $config;
  $img = fullpath($img);
  $tmpfname = tempnam ($config['tempdir'], "imagecomment");
  $cmd  = $config['convert'];
  if ($direction == 'left'){
    $cmd .= ' -rotate 270 ';
  }else{
    $cmd .= ' -rotate 90 ';
  }
  $cmd .= '"'.$img.'" "'.$tmpfname.'"';
  system($cmd);
  if(filesize($tmpfname)){
    copy ($tmpfname,$img);
  }
  unlink($tmpfname);
  $imgbase = preg_replace('/\.(jpe?g|gif|png)$/','',basename($img));
  $thumb = dirname($img).'/.thumbs/'.$imgbase.'.png';
  @unlink($thumb);
}

function getImgComment($img){
  $er = new phpExifReader($img);
  if(!$er){
    return '';
  }
  $er->processFile();
  $exif = $er->getImageInfo();
  if(is_array($exif['imageComment'])){
    $com = join("\n",$exif['imageComment']);
  }else{
    $com = $exif['imageComment'];
  }
  return nohtmlentities($com);
}

function getDirComment($path){
  $path=fullpath($path);
  $com='';
  if(file_exists($path.'/.dirinfo.txt')){
    $com = join('',file($path.'/.dirinfo.txt'));
    $com = nohtmlentities($com);
  }
  return $com;
}

function getThumbnail($path,$img){
  $imgbase = preg_replace('/\.(jpe?g|gif|png)$/','',$img);
  $thumb = $path.'/.thumbs/'.$imgbase.'.png';

  if(file_exists(fullpath($thumb))){
    return $thumb;
  }else{
    return '?thumb='.urlencode($path.'/'.$img);
  }
  return $thumb;
}

function mkThumb($img){
  global $config;
  $img     = fullpath($img);
  $path    = dirname($img);
  $imgbase = basename($img);
  $imgbase = preg_replace('/\.(jpe?g|gif|png)$/','',$imgbase);
  $thumb = $path.'/.thumbs/'.$imgbase.'.png';
  if(!is_dir($path.'/.thumbs')){
    if(!mkdir($path.'/.thumbs',0775)) return(''); #fixme return img
  }
  
  $cmd  = $config['convert'];
  $cmd .= ' -geometry 120x120 ';
  $cmd .= '"'.$img.'" "'.$thumb.'"';
  system($cmd);
  
  header("Content-type: image/png");
  readfile($thumb);
  exit;
}

function readDirectories($path='.'){
  $path=fullpath($path);
  $dirs=array();
  if(! $dir = opendir($path)){
    return $dirs;
  }
  while (($file = readdir($dir)) !== false) {
    if(preg_match('/^\./',$file)){
      continue;
    }
    if(is_dir($path.'/'.$file)){
      $dirs[]=$file;
    }
  }
  closedir($dir);
  sort($dirs,SORT_STRING);
  return $dirs;
}

function readImages($path='.'){
  $path=fullpath($path);
  $imgs=array();
  if(! $dir = opendir($path)){
    return $imgs;
  }
  while (($file = readdir($dir)) !== false) {
    if(preg_match('/^\./',$file)){
      continue;
    }
    if(preg_match('/\.(jpe?g|gif|png)$/i',$file)){
      $imgs[]=$file;
    }
  }
  closedir($dir);
  sort($imgs,SORT_STRING);
  return $imgs;
}

function searchImages($path='.',$query){
  $fullpath = fullpath($path);
  if(! $dir = opendir($fullpath)){
    return;
  }
  while (($file = readdir($dir)) !== false) {
    if(preg_match('/^\./',$file)){
      continue;
    }
    if(is_dir($fullpath.'/'.$file)){
      searchImages($path.'/'.$file,$query);
    }
    if(preg_match('/\.(jpe?g|gif|png)$/i',$file)){
      if(preg_match('/'.$query.'/is',$file)
      || preg_match('/'.$query.'/is',getImgComment($path.'/'.$file))){
        showThumb($path,$file);
      }
    }
    set_time_limit(30);
    flush();
  }
  closedir($dir);
}

function remove_magic_quotes(&$array) {
  foreach (array_keys($array) as $key) {
    if (is_array($array[$key])) {
      remove_magic_quotes($array[$key]);
    }else {
      $array[$key] = stripslashes($array[$key]);
    }
  }
}

function nohtmlentities($string) {
   $string = strtr($string, array_flip(get_html_translation_table(HTML_ENTITIES)));
   $string = preg_replace("/&#([0-9]+);/me", "chr('\\1')", $string);
   return $string;
}

function fullpath($path) {
  global $DOCUMENT_ROOT;
  return ($DOCUMENT_ROOT && substr($path,0,1) == '/' && substr($path,0,strlen($DOCUMENT_ROOT)) != $DOCUMENT_ROOT) ? $DOCUMENT_ROOT.$path : $path;
}
?>
